#ifndef CREATUREDB_H
#define CREATUREDB_H
#include "dbcfile.h"

#include <string>
#include <iostream>
#include "wx/string.h"

class CreatureModelDB: public DBCFile
{
public:
	CreatureModelDB();
	~CreatureModelDB();

	/// Fields
	static const size_t ModelID = 0;		// uint
	static const size_t Type = 1;			// uint
	static const size_t Filename = 2;		// string

	// filenames need to end in mdx though ;(
	Record getByFilename(std::string fn);
private:

};

class CreatureSkinDB: public DBCFile
{
public:
	CreatureSkinDB();
	~CreatureSkinDB();

	/// Fields
	static const size_t SkinID = 0;			// uint
	static const size_t ModelID = 1;		// uint
	static const size_t Scale = 4;			// float
	static const size_t Skin = 6;			// string
	static const size_t Skin2 = 7;			// string
	static const size_t skin3 = 8;			// string

	Record getByModelID(unsigned int id);
	Record getBySkinID(unsigned int id);
};

class NPCDB: public DBCFile
{
public:
	NPCDB();
	~NPCDB();

	/// Fields
	static const size_t NPCID = 0;			// uint
	static const size_t ModelID = 1;		// uint
	static const size_t Gender = 2;			// bool
	//static const size_t HairGeoset = 3;	// uint
	//static const size_t HairSection = 4;	// uint
	static const size_t HairStyle = 5;		// uint
	static const size_t HairColor = 6;		// uint
	static const size_t FacialHair = 7;		// uint
	static const size_t HelmID = 8;			// uint
	static const size_t ShoulderID = 9;		// uint
	static const size_t ShirtID = 10;		// uint
	static const size_t ChestID = 11;		// uint
	static const size_t BeltID = 12;		// uint
	static const size_t PantsID = 13;		// uint
	static const size_t BootsID = 14;		// uint
	static const size_t BracersID = 15;		// uint
	static const size_t GlovesID = 16;		// uint
	static const size_t TabardID = 17;		// uint
	static const size_t Filename = 18;		// string

	Record getByFilename(std::string fn);
	Record getByNPCID(unsigned int id);

};

#endif
