#ifndef VIEWCONTROL_H
#define VIEWCONTROL_H

#include "wx/wxprec.h"
#ifdef __BORLANDC__
    #pragma hdrstop
#endif
#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

// wxwidgets
#include "wx/radiobut.h"

// custom headers
#include "vec3d.h"
#include "quaternion.h"

// custom objects
class ModelViewer;
class ModelCanvas;

enum {
	ID_VIEWFRAME = 3200,
	ID_FOV,
	ID_ASPECT,
	ID_POSX,
	ID_POSY,
	ID_POSZ,
	ID_ROTX,
	ID_ROTY,
	ID_ROTZ,
	ID_LIGHTX,
	ID_LIGHTY,
	ID_LIGHTZ,
	ID_UPDATE,
	ID_SAVE,
	ID_LOAD,
	ID_RESET,
	ID_MOUSE_MODEL,
	ID_MOUSE_LIGHT
};

class ViewControl: public wxWindow
{
	DECLARE_CLASS(ViewControl)
    DECLARE_EVENT_TABLE()

	Vec4D vLight;
	Vec3D vPos, vRot;
	
	wxTextCtrl *txtFov;
	wxTextCtrl *txtPos[3];
	wxTextCtrl *txtRot[3];
	wxTextCtrl *txtLight[3];

public:

	ViewControl(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize);
	~ViewControl();
	
	void OnButton(wxCommandEvent &event);
	void OnText(wxCommandEvent &event);
	void Init();
	void Refresh();
	void Update();
	
	ModelViewer *modelViewer;
	ModelCanvas *canvas;
};


#endif

